/*
*************************************************************************************
* Disc:  					A basic program for Q's 8x6 PLC Project														*
*									Includes all I/O init functions, some basicl UART com functions		*
*									& EEPROM functions functionality																	*
*																																										*
* Version:				Alpha																															*
* Date:						1 Dec 2009																												*
* Author:					Q																																	*
* Demo Project: 	https://sites.google.com/site/qeewiki/projects/plc								*
*************************************************************************************
*/



#include <avr/io.h>


// **********************************************************************************
// *** IO

// INPUTS
#define IN1 (PINB & (1<<1))
#define IN2 (PINB & (1<<2))
#define IN3 (PINB & (1<<4))
#define IN4 (PINB & (1<<5))
#define IN5 (PINC & (1<<1))
#define IN6 (PINC & (1<<2))
#define IN7 (PINC & (1<<3))
#define IN8 (PINB & (1<<0))
#define INPUTS ((IN1 == 0) + ((IN2 == 0) << 1) + ((IN3 == 0) << 2) + ((IN4 == 0) << 3) + ((IN5 == 0) << 4) + ((IN6 == 0) << 5) + ((IN7 == 0) << 6) + ((IN8 == 0) << 7))


// **********************************************************************************
// *** OUTPUT FUNCTION MACROS
#define ON 1
#define OFF 0
#define FLIP 2



// **********************************************************************************
// *** USART DEFINES
#define USART_BAUDRATE 9600
#define BAUD_PRESCALE (((F_CPU / (USART_BAUDRATE * 16UL))) - 1) 


// **********************************************************************************
// *** UPDATE REGISTER
//volatile uint8_t update
//#define TIMER 0


// **********************************************************************************
// *** GLOBAL VARS


// USART VARS
volatile char ReceivedByte;

// I/O display holding vars
volatile uint8_t outputs;
volatile uint8_t output_force_mask;

// Time
volatile uint8_t timer;


// **********************************************************************************
// FUNCTION DEFS

void output(uint8_t* bit, uint8_t enable);



// **********************************************************************************
// FUNCTION DEFS

void uart_print_hexcodes(uint8_t hexcode);
void uart_IO_print(uint16_t IOvalue, uint8_t count);
void uart_print(char *bufferstring);
void decodecommand(void);
void asciitohex(void);
void uart_macros(void);
void uart_commands(uint8_t* cmd);
