/*
*************************************************************************************
* Disc:  					A basic program for Q's 8x6 PLC Project														*
*									Includes all I/O init functions, some basicl UART com functions		*
*									& EEPROM functions functionality																	*
*																																										*
* Version:				Alpha																															*
* Date:						1 Dec 2009																												*																																	*
* Demo Project								*
*************************************************************************************
*/


#include <avr/io.h>
#include <util/delay.h>
#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include "main.h"


// **********************************************************************************
// *** PRINTS OUT AN 8 BIT DIGIT AT AS HEX ASCII VALUE 00 TO FF
void uart_print_hexcodes(uint8_t hexcode)
{
	uint8_t oldhex = hexcode;
	uint8_t tmp;

	tmp = (hexcode >> 4);

	if (tmp > 9)
	{
		tmp = tmp + 7;
	}
	UDR0 = tmp + 48; 

	while(!(UCSR0A & (1<<UDRE0))); //wait until previous char has been sent

	tmp = (oldhex << 4);
	tmp = tmp >> 4;	

	if (tmp > 9)
	{
		tmp = tmp + 7;
	}
	UDR0 = tmp + 48; 

}



// **********************************************************************************
// *** Prints out the value of IOvalue in binary
void uart_IO_print(uint16_t IOvalue, uint8_t count){

	uint8_t i; 
	for(i=(count-1);i < count && i >= 0;i--)
	{
		while(!(UCSR0A & (1<<UDRE0))); 			//wait until previous char has been sent

		UDR0 = ((IOvalue & (1<<i)) > 0) + 48; 	//converts int values into ascii values
	} 
	UDR0 = 13;									//charage return
}



// **********************************************************************************
// a function for printing a string on the UART
// stdint.h should be included
void uart_print(char *bufferstring){ 	//this function sends a string of

	//characters to the computer
	uint8_t i=0;
	while(bufferstring[i]!='\0'){ 		//loop until the end of the string
		while(!(UCSR0A & (1<<UDRE0))); 	//wait until previous char has been sent

		UDR0=bufferstring[i++]; 		//send character
	}
}



// **********************************************************************************
// a function that exicutes quick macro commands
// stdint.h should be included
void uart_macros(void){
	
	// Print Input Status
	if (ReceivedByte == 'I')
	{
		//printf("Input status:");
		uart_IO_print(INPUTS, 8);
	}
	// Print Output Status
	else if (ReceivedByte == 'O')
	{
		//printf("Output status:");
		uart_IO_print((PORTD>>2), 6);
	}
	else if (ReceivedByte == 'R')
	{
		
	}
	// activate flip bit 1 to 6 in the mask
	else if (ReceivedByte >= 49 && ReceivedByte <= 54)
	{
		// flip
		output_force_mask ^= (1 << (ReceivedByte - 49));
	}


	else
	{
   		// Echo anything else
		UDR0 = '?';
	}

}




// **********************************************************************************
// a function that decodes uart command
// 
void uart_commands(uint8_t* cmd){
	
	// inputs = 117
	if(*cmd == 117)
	{
		//printf("Output status:");
		uart_IO_print((PORTD>>2), 6);
	}


	//inmask

	// outputs = 132
	else if(*cmd == 132)
	{
		uart_IO_print(INPUTS, 8);
	}

	// outmask



	// ain

	// rpwm

	// wpwm



	// rmem == 49

	// wmem == 53
}

